<template>
  <div class="flex flex-col h-screen text-[4.5vw]">
    <header class="text-center bg-white">
      <div class="h-[11.735vw] flex justify-center items-center text-black">
        {{ $t("promotion") }}
      </div>
      <div class="tab px-4">
        <div
          v-for="tab in Object.entries(initPromotions)"
          :key="tab[0]"
          :class="{ active: tab[1].IsActive }"
          @click="onTabClick(tab[0])"
        >
          {{ $t(tab[1].Name) }}
        </div>
      </div>
    </header>
    <div
      v-if="
        selectedPromotions[0] && selectedPromotions[0].Promotions.length < 1
      "
      class="flex flex-col justify-center items-center mt-[25px]"
    >
      <div class="text-center text-black mt-4">
        {{ $t("no_promotion_info") }}
      </div>
      <span class="font-bold text-sm text-black">{{ assignHashText }}</span>
    </div>
    <main
      v-if="
        selectedPromotions[0] && selectedPromotions[0].Promotions.length > 0
      "
      class="flex-1 overflow-y-auto p-[3.735vw] pt-3 mb-[10%]"
    >
      <div
        v-for="promotion in selectedPromotions[0].Promotions"
        :key="promotion.Id"
      >
        <china-promotion-card
          :promotion="promotion"
          @click="$router.push(`?id=${promotion.Id}`)"
          :key="'card' + promotion.Id"
        />
        <china-promotion-detail
          :show="Number($route.query.id) == promotion.Id"
          :promotion="promotion"
          :key="'detail' + promotion.Id"
        />
      </div>
    </main>
  </div>
</template>

<script lang="ts">
import { defineComponent, computed, reactive } from "vue";
import { Promotion } from "@/models/promotion/promotion";
import { store } from "~~/store";

interface IPromotionLFM1 {
  Name: string;
  SearchKey: string;
  AvoidKey: string[];
  IsAll: boolean;
  Promotions: Array<Promotion>;
  IsActive: boolean;
}

export default defineComponent({
  name: "Promotion",
  setup() {
    const { promotions, assignHashText } = usePromotion();
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const presetConditions = reactive<Record<string, IPromotionLFM1>>({
      AllOffer: {
        Name: "all_offer",
        Promotions: [],
        SearchKey: "",
        IsAll: true,
        AvoidKey: [],
        IsActive: true,
      },
      FirstDeposit: {
        Name: "first_deposit",
        Promotions: [],
        SearchKey: "First Deposit",
        IsAll: false,
        AvoidKey: [],
        IsActive: false,
      },
      Common: {
        Name: "common",
        Promotions: [],
        SearchKey: "",
        AvoidKey: ["First Deposit", "Rebate On"],
        IsAll: false,
        IsActive: false,
      },
      RebateOffer: {
        Name: "rebate_offer",
        Promotions: [],
        SearchKey: "Rebate On",
        AvoidKey: [],
        IsActive: false,
        IsAll: false,
      },
    });

    const initPromotions = computed(() => {
      const finalPromotions: Record<string, IPromotionLFM1> = presetConditions;
      if (promotions.value.length < 1) {
        return finalPromotions;
      }
      Object.entries(finalPromotions).forEach(([key, value]) => {
        if (value.IsAll) {
          finalPromotions[key].Promotions = promotions.value.map(
            (p) => new Promotion(p)
          );
          return;
        }
        let tempPromotions = promotions.value.filter((p) =>
          p.PromotionType.includes(value.SearchKey)
        );

        if (value.AvoidKey.length > 0) {
          value.AvoidKey.forEach((k) => {
            tempPromotions = tempPromotions.filter(
              (p) => !p.PromotionType.includes(k)
            );
          });
        }
        finalPromotions[key].Promotions = tempPromotions.map(
          (p) => new Promotion(p)
        );
      });
      return finalPromotions;
    });

    const selectedPromotions = computed(() =>
      Object.values(initPromotions.value).filter(
        (pfd: IPromotionLFM1) => pfd.IsActive
      )
    );
    const onTabClick = (key: string) => {
      Object.keys(presetConditions).forEach((item) => {
        presetConditions[item].IsActive = false;
      });
      presetConditions[key].IsActive = true;
    };

    return {
      selectedPromotions,
      initPromotions,
      onTabClick,
      assignHashText,
      themeProperties,
    };
  },
});
</script>

<style scoped lang="scss">
.tab {
  display: flex;
  overflow: auto;
  justify-content: space-between;

  & > * {
    color: gray;
    cursor: pointer;
    white-space: nowrap;
    @apply p-3;
  }

  & .active {
    border-bottom: 3px solid #3d72fa;
    color: black;
  }
}
</style>
